Issue #13863 has been updated by dogatana (Toshihiko Ichida).


> RUBYLIB  などでは問題ないようですね。なるほど。

そうですね。
a2.rb で −I. を使用する場合だと、require が失敗するだけで、
いきなり終了する現象は出ません。

require が失敗するケースも対策されるとうれしいです。



----------------------------------------
Bug #13863: RUBYLIB にカレントディレクトリを設定した場合、−E cp932:utf-8 を指定するとスクリプトが全く実行されない
https://bugs.ruby-lang.org/issues/13863#change-66486

* Author: dogatana (Toshihiko Ichida)
* Status: Open
* Priority: Normal
* Assignee: 
* Target version: 
* ruby -v: ruby 2.4.1p111 (2017-03-22 revision 58053) [i386-mingw32]
* Backport: 2.2: WONTFIX, 2.3: REQUIRED, 2.4: REQUIRED
----------------------------------------
こんにちは。

Windows 環境の ruby での話です。

http://blade.nagaokaut.ac.jp/cgi-bin/scat.rb/ruby/ruby-list/49186
https://bugs.ruby-lang.org/issues/7881

について、これは少なくとも

* ruby 2.3.3p222 (2016-11-21 revision 56859) [i386-mingw32]
* ruby 2.4.1p111 (2017-03-22 revision 58053) [i386-mingw32]

では発生せず、対策されているようです。

ただし、

* 環境変数 RUBYLIBにカンレントディレクトリ(.)を設定
* -E cp932:utf-8 を指定

して上のリンクにある a.rb を実行すると、

ruby 2.3.3p222 (2016-11-21 revision 56859) [i386-mingw32]  では

~~~
> ruby -E cp932:utf-8 a.rb
<internal:enc/prelude>:4:in `require': stack level too deep (SystemStackError)
        from <internal:enc/prelude>:4:in `<internal:enc/prelude>'

~~~

と表示され、即座に終了し、
ruby 2.4.1p111 (2017-03-22 revision 58053) [i386-mingw32] では

~~~
> ruby -E cp932:utf-8 a.rb
~~~

と何も表示せず、ruby が終了します。
(内部では SystemStackError が発生?)

-E オプションは標準出力を cp932 で出力したいためで、今はIO#set_encoding を使用するようにして対処していますが、
本質的には ruby 側での対策が望ましいのではと思います。

いかがでしょうか。


市田



-- 
https://bugs.ruby-lang.org/